# generated by datamodel-codegen:
#   filename:  https://raw.githubusercontent.com/hashicorp/nomad-openapi/main/v1/openapi.yaml
#   timestamp: 2022-05-31T20:30:40+00:00

from __future__ import annotations

from datetime import datetime
from typing import Any, Dict, List, Optional

from pydantic import BaseModel, Extra, Field, conint


class ACLPolicy(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Description: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None
    Rules: Optional[str] = None


class ACLPolicyListStub(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Description: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None


class ACLToken(BaseModel):
    AccessorID: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    CreateTime: Optional[datetime] = None
    Global: Optional[bool] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None
    Policies: Optional[List[str]] = None
    SecretID: Optional[str] = None
    Type: Optional[str] = None


class ACLTokenListStub(BaseModel):
    AccessorID: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    CreateTime: Optional[datetime] = None
    Global: Optional[bool] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None
    Policies: Optional[List[str]] = None
    Type: Optional[str] = None


class Affinity(BaseModel):
    LTarget: Optional[str] = None
    Operand: Optional[str] = None
    RTarget: Optional[str] = None
    Weight: Optional[conint(ge=-128, le=127)] = None


class AllocDeploymentStatus(BaseModel):
    Canary: Optional[bool] = None
    Healthy: Optional[bool] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Timestamp: Optional[datetime] = None


class AllocStopResponse(BaseModel):
    EvalID: Optional[str] = None
    Index: Optional[conint(ge=0, le=18446744073709551616)] = None


class AllocatedCpuResources(BaseModel):
    CpuShares: Optional[int] = None


class AllocatedDeviceResource(BaseModel):
    DeviceIDs: Optional[List[str]] = None
    Name: Optional[str] = None
    Type: Optional[str] = None
    Vendor: Optional[str] = None


class AllocatedMemoryResources(BaseModel):
    MemoryMB: Optional[int] = None
    MemoryMaxMB: Optional[int] = None


class Attribute(BaseModel):
    Bool: Optional[bool] = None
    Float: Optional[float] = None
    Int: Optional[int] = None
    String: Optional[str] = None
    Unit: Optional[str] = None


class AutopilotConfiguration(BaseModel):
    CleanupDeadServers: Optional[bool] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    DisableUpgradeMigration: Optional[bool] = None
    EnableCustomUpgrades: Optional[bool] = None
    EnableRedundancyZones: Optional[bool] = None
    LastContactThreshold: Optional[str] = None
    MaxTrailingLogs: Optional[conint(ge=0, le=18446744073709551616)] = None
    MinQuorum: Optional[conint(ge=0)] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ServerStabilizationTime: Optional[str] = None


class CSIControllerInfo(BaseModel):
    SupportsAttachDetach: Optional[bool] = None
    SupportsClone: Optional[bool] = None
    SupportsCondition: Optional[bool] = None
    SupportsCreateDelete: Optional[bool] = None
    SupportsCreateDeleteSnapshot: Optional[bool] = None
    SupportsExpand: Optional[bool] = None
    SupportsGet: Optional[bool] = None
    SupportsGetCapacity: Optional[bool] = None
    SupportsListSnapshots: Optional[bool] = None
    SupportsListVolumes: Optional[bool] = None
    SupportsListVolumesAttachedNodes: Optional[bool] = None
    SupportsReadOnlyAttach: Optional[bool] = None


class CSIMountOptions(BaseModel):
    FSType: Optional[str] = None
    MountFlags: Optional[List[str]] = None


class CSIPluginListStub(BaseModel):
    ControllerRequired: Optional[bool] = None
    ControllersExpected: Optional[int] = None
    ControllersHealthy: Optional[int] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ID: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NodesExpected: Optional[int] = None
    NodesHealthy: Optional[int] = None
    Provider: Optional[str] = None


class CSIPluginType(BaseModel):
    __root__: str


class CSISecrets(BaseModel):
    pass

    class Config:
        extra = Extra.allow


class CSISnapshot(BaseModel):
    CreateTime: Optional[int] = None
    ExternalSourceVolumeID: Optional[str] = None
    ID: Optional[str] = None
    IsReady: Optional[bool] = None
    Name: Optional[str] = None
    Parameters: Optional[Dict[str, str]] = None
    PluginID: Optional[str] = None
    Secrets: Optional[CSISecrets] = None
    SizeBytes: Optional[int] = None
    SourceVolumeID: Optional[str] = None


class CSISnapshotCreateRequest(BaseModel):
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None
    Snapshots: Optional[List[CSISnapshot]] = None


class CSISnapshotCreateResponse(BaseModel):
    KnownLeader: Optional[bool] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NextToken: Optional[str] = None
    RequestTime: Optional[int] = None
    Snapshots: Optional[List[CSISnapshot]] = None


class CSISnapshotListResponse(BaseModel):
    KnownLeader: Optional[bool] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NextToken: Optional[str] = None
    RequestTime: Optional[int] = None
    Snapshots: Optional[List[CSISnapshot]] = None


class CSITopology(BaseModel):
    Segments: Optional[Dict[str, str]] = None


class CSITopologyRequest(BaseModel):
    Preferred: Optional[List[CSITopology]] = None
    Required: Optional[List[CSITopology]] = None


class CSIVolumeAccessMode(BaseModel):
    __root__: str


class CSIVolumeAttachmentMode(BaseModel):
    __root__: str


class CSIVolumeCapability(BaseModel):
    AccessMode: Optional[str] = None
    AttachmentMode: Optional[str] = None


class CSIVolumeExternalStub(BaseModel):
    CapacityBytes: Optional[int] = None
    CloneID: Optional[str] = None
    ExternalID: Optional[str] = None
    IsAbnormal: Optional[bool] = None
    PublishedExternalNodeIDs: Optional[List[str]] = None
    SnapshotID: Optional[str] = None
    Status: Optional[str] = None
    VolumeContext: Optional[Dict[str, str]] = None


class CSIVolumeListExternalResponse(BaseModel):
    NextToken: Optional[str] = None
    Volumes: Optional[List[CSIVolumeExternalStub]] = None


class CSIVolumeListStub(BaseModel):
    AccessMode: Optional[str] = None
    AttachmentMode: Optional[str] = None
    ControllerRequired: Optional[bool] = None
    ControllersExpected: Optional[int] = None
    ControllersHealthy: Optional[int] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ExternalID: Optional[str] = None
    ID: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None
    Namespace: Optional[str] = None
    NodesExpected: Optional[int] = None
    NodesHealthy: Optional[int] = None
    PluginID: Optional[str] = None
    Provider: Optional[str] = None
    ResourceExhausted: Optional[datetime] = None
    Schedulable: Optional[bool] = None
    Topologies: Optional[List[CSITopology]] = None


class CheckRestart(BaseModel):
    Grace: Optional[int] = None
    IgnoreWarnings: Optional[bool] = None
    Limit: Optional[int] = None


class Constraint(BaseModel):
    LTarget: Optional[str] = None
    Operand: Optional[str] = None
    RTarget: Optional[str] = None


class Consul(BaseModel):
    Namespace: Optional[str] = None


class ConsulExposePath(BaseModel):
    ListenerPort: Optional[str] = None
    LocalPathPort: Optional[int] = None
    Path: Optional[str] = None
    Protocol: Optional[str] = None


class ConsulGatewayBindAddress(BaseModel):
    Address: Optional[str] = None
    Name: Optional[str] = None
    Port: Optional[int] = None


class ConsulGatewayProxy(BaseModel):
    Config_: Optional[Dict[str, Any]] = Field(None, alias="Config")
    ConnectTimeout: Optional[int] = None
    EnvoyDNSDiscoveryType: Optional[str] = None
    EnvoyGatewayBindAddresses: Optional[Dict[str, ConsulGatewayBindAddress]] = None
    EnvoyGatewayBindTaggedAddresses: Optional[bool] = None
    EnvoyGatewayNoDefaultBind: Optional[bool] = None


class ConsulGatewayTLSConfig(BaseModel):
    Enabled: Optional[bool] = None


class ConsulIngressService(BaseModel):
    Hosts: Optional[List[str]] = None
    Name: Optional[str] = None


class ConsulLinkedService(BaseModel):
    CAFile: Optional[str] = None
    CertFile: Optional[str] = None
    KeyFile: Optional[str] = None
    Name: Optional[str] = None
    SNI: Optional[str] = None


class ConsulMeshConfigEntry(BaseModel):
    __root__: Any


class ConsulMeshGateway(BaseModel):
    Mode: Optional[str] = None


class ConsulTerminatingConfigEntry(BaseModel):
    Services: Optional[List[ConsulLinkedService]] = None


class ConsulUpstream(BaseModel):
    Datacenter: Optional[str] = None
    DestinationName: Optional[str] = None
    LocalBindAddress: Optional[str] = None
    LocalBindPort: Optional[int] = None
    MeshGateway: Optional[ConsulMeshGateway] = None


class Context(BaseModel):
    __root__: str


class DNSConfig(BaseModel):
    Options: Optional[List[str]] = None
    Searches: Optional[List[str]] = None
    Servers: Optional[List[str]] = None


class DeploymentAllocHealthRequest(BaseModel):
    DeploymentID: Optional[str] = None
    HealthyAllocationIDs: Optional[List[str]] = None
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None
    UnhealthyAllocationIDs: Optional[List[str]] = None


class DeploymentPauseRequest(BaseModel):
    DeploymentID: Optional[str] = None
    Namespace: Optional[str] = None
    Pause: Optional[bool] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None


class DeploymentPromoteRequest(BaseModel):
    All: Optional[bool] = None
    DeploymentID: Optional[str] = None
    Groups: Optional[List[str]] = None
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None


class DeploymentState(BaseModel):
    AutoRevert: Optional[bool] = None
    DesiredCanaries: Optional[int] = None
    DesiredTotal: Optional[int] = None
    HealthyAllocs: Optional[int] = None
    PlacedAllocs: Optional[int] = None
    PlacedCanaries: Optional[List[str]] = None
    ProgressDeadline: Optional[int] = None
    Promoted: Optional[bool] = None
    RequireProgressBy: Optional[datetime] = None
    UnhealthyAllocs: Optional[int] = None


class DeploymentUnblockRequest(BaseModel):
    DeploymentID: Optional[str] = None
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None


class DeploymentUpdateResponse(BaseModel):
    DeploymentModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalID: Optional[str] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    RequestTime: Optional[int] = None
    RevertedJobVersion: Optional[conint(ge=0, le=18446744073709551616)] = None


class DesiredTransition(BaseModel):
    Migrate: Optional[bool] = None
    Reschedule: Optional[bool] = None


class DesiredUpdates(BaseModel):
    Canary: Optional[conint(ge=0, le=18446744073709551616)] = None
    DestructiveUpdate: Optional[conint(ge=0, le=18446744073709551616)] = None
    Ignore: Optional[conint(ge=0, le=18446744073709551616)] = None
    InPlaceUpdate: Optional[conint(ge=0, le=18446744073709551616)] = None
    Migrate: Optional[conint(ge=0, le=18446744073709551616)] = None
    Place: Optional[conint(ge=0, le=18446744073709551616)] = None
    Preemptions: Optional[conint(ge=0, le=18446744073709551616)] = None
    Stop: Optional[conint(ge=0, le=18446744073709551616)] = None


class DispatchPayloadConfig(BaseModel):
    File: Optional[str] = None


class DrainMetadata(BaseModel):
    AccessorID: Optional[str] = None
    Meta: Optional[Dict[str, str]] = None
    StartedAt: Optional[datetime] = None
    Status: Optional[str] = None
    UpdatedAt: Optional[datetime] = None


class DrainSpec(BaseModel):
    Deadline: Optional[int] = None
    IgnoreSystemJobs: Optional[bool] = None


class DrainStatus(BaseModel):
    __root__: str


class DrainStrategy(BaseModel):
    Deadline: Optional[int] = None
    ForceDeadline: Optional[datetime] = None
    IgnoreSystemJobs: Optional[bool] = None
    StartedAt: Optional[datetime] = None


class DriverInfo(BaseModel):
    Attributes: Optional[Dict[str, str]] = None
    Detected: Optional[bool] = None
    HealthDescription: Optional[str] = None
    Healthy: Optional[bool] = None
    UpdateTime: Optional[datetime] = None


class Duration(BaseModel):
    __root__: int


class EphemeralDisk(BaseModel):
    Migrate: Optional[bool] = None
    SizeMB: Optional[int] = None
    Sticky: Optional[bool] = None


class EvalOptions(BaseModel):
    ForceReschedule: Optional[bool] = None


class EvaluationStub(BaseModel):
    BlockedEval: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    CreateTime: Optional[int] = None
    DeploymentID: Optional[str] = None
    ID: Optional[str] = None
    JobID: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ModifyTime: Optional[int] = None
    Namespace: Optional[str] = None
    NextEval: Optional[str] = None
    NodeID: Optional[str] = None
    PreviousEval: Optional[str] = None
    Priority: Optional[int] = None
    Status: Optional[str] = None
    StatusDescription: Optional[str] = None
    TriggeredBy: Optional[str] = None
    Type: Optional[str] = None
    WaitUntil: Optional[datetime] = None


class FieldDiff(BaseModel):
    Annotations: Optional[List[str]] = None
    Name: Optional[str] = None
    New: Optional[str] = None
    Old: Optional[str] = None
    Type: Optional[str] = None


class FuzzyMatch(BaseModel):
    ID: Optional[str] = None
    Scope: Optional[List[str]] = None


class FuzzySearchRequest(BaseModel):
    AllowStale: Optional[bool] = None
    AuthToken: Optional[str] = None
    Context: Optional[str] = None
    Filter: Optional[str] = None
    Headers: Optional[Dict[str, str]] = None
    Namespace: Optional[str] = None
    NextToken: Optional[str] = None
    Params: Optional[Dict[str, str]] = None
    PerPage: Optional[int] = None
    Prefix: Optional[str] = None
    Region: Optional[str] = None
    Reverse: Optional[bool] = None
    Text: Optional[str] = None
    WaitIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    WaitTime: Optional[int] = None


class FuzzySearchResponse(BaseModel):
    KnownLeader: Optional[bool] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Matches: Optional[Dict[str, List[FuzzyMatch]]] = None
    NextToken: Optional[str] = None
    RequestTime: Optional[int] = None
    Truncations: Optional[Dict[str, bool]] = None


class GaugeValue(BaseModel):
    Labels: Optional[Dict[str, str]] = None
    Name: Optional[str] = None
    Value: Optional[float] = None


class HostNetworkInfo(BaseModel):
    CIDR: Optional[str] = None
    Interface: Optional[str] = None
    Name: Optional[str] = None
    ReservedPorts: Optional[str] = None


class HostVolumeInfo(BaseModel):
    Path: Optional[str] = None
    ReadOnly: Optional[bool] = None


class JobChildrenSummary(BaseModel):
    Dead: Optional[int] = None
    Pending: Optional[int] = None
    Running: Optional[int] = None


class JobDeregisterResponse(BaseModel):
    EvalCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalID: Optional[str] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    KnownLeader: Optional[bool] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NextToken: Optional[str] = None
    RequestTime: Optional[int] = None


class JobDispatchRequest(BaseModel):
    JobID: Optional[str] = None
    Meta: Optional[Dict[str, str]] = None
    Payload: Optional[str] = None


class JobDispatchResponse(BaseModel):
    DispatchedJobID: Optional[str] = None
    EvalCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalID: Optional[str] = None
    JobCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    RequestTime: Optional[int] = None


class JobEvaluateRequest(BaseModel):
    EvalOptions: Optional[EvalOptions] = None
    JobID: Optional[str] = None
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None


class JobRegisterResponse(BaseModel):
    EvalCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalID: Optional[str] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    KnownLeader: Optional[bool] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NextToken: Optional[str] = None
    RequestTime: Optional[int] = None
    Warnings: Optional[str] = None


class JobRevertRequest(BaseModel):
    ConsulToken: Optional[str] = None
    EnforcePriorVersion: Optional[conint(ge=0, le=18446744073709551616)] = None
    JobID: Optional[str] = None
    JobVersion: Optional[conint(ge=0, le=18446744073709551616)] = None
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None
    VaultToken: Optional[str] = None


class JobStabilityRequest(BaseModel):
    JobID: Optional[str] = None
    JobVersion: Optional[conint(ge=0, le=18446744073709551616)] = None
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None
    Stable: Optional[bool] = None


class JobStabilityResponse(BaseModel):
    Index: Optional[conint(ge=0, le=18446744073709551616)] = None


class JobValidateResponse(BaseModel):
    DriverConfigValidated: Optional[bool] = None
    Error: Optional[str] = None
    ValidationErrors: Optional[List[str]] = None
    Warnings: Optional[str] = None


class JobsParseRequest(BaseModel):
    Canonicalize: Optional[bool] = None
    JobHCL: Optional[str] = None
    hclv1: Optional[bool] = None


class LogConfig(BaseModel):
    MaxFileSizeMB: Optional[int] = None
    MaxFiles: Optional[int] = None


class MigrateStrategy(BaseModel):
    HealthCheck: Optional[str] = None
    HealthyDeadline: Optional[int] = None
    MaxParallel: Optional[int] = None
    MinHealthyTime: Optional[int] = None


class MultiregionRegion(BaseModel):
    Count: Optional[int] = None
    Datacenters: Optional[List[str]] = None
    Meta: Optional[Dict[str, str]] = None
    Name: Optional[str] = None


class MultiregionStrategy(BaseModel):
    MaxParallel: Optional[int] = None
    OnFailure: Optional[str] = None


class NamespaceCapabilities(BaseModel):
    DisabledTaskDrivers: Optional[List[str]] = None
    EnabledTaskDrivers: Optional[List[str]] = None


class NodeCpuResources(BaseModel):
    CpuShares: Optional[int] = None
    ReservableCpuCores: Optional[List[conint(ge=0, le=65535)]] = None
    TotalCpuCores: Optional[conint(ge=0, le=65535)] = None


class NodeDeviceLocality(BaseModel):
    PciBusID: Optional[str] = None


class NodeDiskResources(BaseModel):
    DiskMB: Optional[int] = None


class NodeDrainUpdateResponse(BaseModel):
    EvalCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalIDs: Optional[List[str]] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NodeModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    RequestTime: Optional[int] = None


class NodeEligibilityUpdateResponse(BaseModel):
    EvalCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalIDs: Optional[List[str]] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NodeModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    RequestTime: Optional[int] = None


class NodeEvent(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Details: Optional[Dict[str, str]] = None
    Message: Optional[str] = None
    Subsystem: Optional[str] = None
    Timestamp: Optional[datetime] = None


class NodeMemoryResources(BaseModel):
    MemoryMB: Optional[int] = None


class NodePurgeResponse(BaseModel):
    EvalCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalIDs: Optional[List[str]] = None
    NodeModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None


class NodeReservedCpuResources(BaseModel):
    CpuShares: Optional[conint(ge=0, le=18446744073709551616)] = None


class NodeReservedDiskResources(BaseModel):
    DiskMB: Optional[conint(ge=0, le=18446744073709551616)] = None


class NodeReservedMemoryResources(BaseModel):
    MemoryMB: Optional[conint(ge=0, le=18446744073709551616)] = None


class NodeReservedNetworkResources(BaseModel):
    ReservedHostPorts: Optional[str] = None


class NodeReservedResources(BaseModel):
    Cpu: Optional[NodeReservedCpuResources] = None
    Disk: Optional[NodeReservedDiskResources] = None
    Memory: Optional[NodeReservedMemoryResources] = None
    Networks: Optional[NodeReservedNetworkResources] = None


class NodeScoreMeta(BaseModel):
    NodeID: Optional[str] = None
    NormScore: Optional[float] = None
    Scores: Optional[Dict[str, float]] = None


class NodeUpdateDrainRequest(BaseModel):
    DrainSpec: Optional[DrainSpec] = None
    MarkEligible: Optional[bool] = None
    Meta: Optional[Dict[str, str]] = None
    NodeID: Optional[str] = None


class NodeUpdateEligibilityRequest(BaseModel):
    Eligibility: Optional[str] = None
    NodeID: Optional[str] = None


class ObjectDiff(BaseModel):
    Fields: Optional[List[FieldDiff]] = None
    Name: Optional[str] = None
    Objects: Optional[List[ObjectDiff]] = None
    Type: Optional[str] = None


class OneTimeToken(BaseModel):
    AccessorID: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ExpiresAt: Optional[datetime] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    OneTimeSecretID: Optional[str] = None


class OneTimeTokenExchangeRequest(BaseModel):
    OneTimeSecretID: Optional[str] = None


class ParameterizedJobConfig(BaseModel):
    MetaOptional: Optional[List[str]] = None
    MetaRequired: Optional[List[str]] = None
    Payload: Optional[str] = None


class PeriodicConfig(BaseModel):
    Enabled: Optional[bool] = None
    ProhibitOverlap: Optional[bool] = None
    Spec: Optional[str] = None
    SpecType: Optional[str] = None
    TimeZone: Optional[str] = None


class PeriodicForceResponse(BaseModel):
    EvalCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    EvalID: Optional[str] = None
    Index: Optional[conint(ge=0, le=18446744073709551616)] = None


class PointValue(BaseModel):
    Name: Optional[str] = None
    Points: Optional[List[float]] = None


class Port(BaseModel):
    HostNetwork: Optional[str] = None
    Label: Optional[str] = None
    To: Optional[int] = None
    Value: Optional[int] = None


class PortMapping(BaseModel):
    HostIP: Optional[str] = None
    Label: Optional[str] = None
    To: Optional[int] = None
    Value: Optional[int] = None


class PreemptionConfig(BaseModel):
    BatchSchedulerEnabled: Optional[bool] = None
    ServiceSchedulerEnabled: Optional[bool] = None
    SysBatchSchedulerEnabled: Optional[bool] = None
    SystemSchedulerEnabled: Optional[bool] = None


class Quotas(BaseModel):
    __root__: Any


class RaftServer(BaseModel):
    Address: Optional[str] = None
    ID: Optional[str] = None
    Leader: Optional[bool] = None
    Node: Optional[str] = None
    RaftProtocol: Optional[str] = None
    Voter: Optional[bool] = None


class RequestedDevice(BaseModel):
    Affinities: Optional[List[Affinity]] = None
    Constraints: Optional[List[Constraint]] = None
    Count: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None


class RescheduleEvent(BaseModel):
    PrevAllocID: Optional[str] = None
    PrevNodeID: Optional[str] = None
    RescheduleTime: Optional[int] = None


class ReschedulePolicy(BaseModel):
    Attempts: Optional[int] = None
    Delay: Optional[int] = None
    DelayFunction: Optional[str] = None
    Interval: Optional[int] = None
    MaxDelay: Optional[int] = None
    Unlimited: Optional[bool] = None


class RescheduleTracker(BaseModel):
    Events: Optional[List[RescheduleEvent]] = None


class RestartPolicy(BaseModel):
    Attempts: Optional[int] = None
    Delay: Optional[int] = None
    Interval: Optional[int] = None
    Mode: Optional[str] = None


class SampledValue(BaseModel):
    Count: Optional[int] = None
    Labels: Optional[Dict[str, str]] = None
    Max: Optional[float] = None
    Mean: Optional[float] = None
    Min: Optional[float] = None
    Name: Optional[str] = None
    Rate: Optional[float] = None
    Stddev: Optional[float] = None
    Sum: Optional[float] = None


class ScalingEvent(BaseModel):
    Count: Optional[int] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Error: Optional[bool] = None
    EvalID: Optional[str] = None
    Message: Optional[str] = None
    Meta: Optional[Dict[str, Any]] = None
    PreviousCount: Optional[int] = None
    Time: Optional[conint(ge=0, le=18446744073709551616)] = None


class ScalingPolicy(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Enabled: Optional[bool] = None
    ID: Optional[str] = None
    Max: Optional[int] = None
    Min: Optional[int] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Namespace: Optional[str] = None
    Policy: Optional[Dict[str, Any]] = None
    Target: Optional[Dict[str, str]] = None
    Type: Optional[str] = None


class ScalingPolicyListStub(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Enabled: Optional[bool] = None
    ID: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Target: Optional[Dict[str, str]] = None
    Type: Optional[str] = None


class ScalingRequest(BaseModel):
    Count: Optional[int] = None
    Error: Optional[bool] = None
    Message: Optional[str] = None
    Meta: Optional[Dict[str, Any]] = None
    Namespace: Optional[str] = None
    PolicyOverride: Optional[bool] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None
    Target: Optional[Dict[str, str]] = None


class SchedulerAlgorithm(BaseModel):
    __root__: str


class SchedulerConfiguration(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    MemoryOversubscriptionEnabled: Optional[bool] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    PreemptionConfig: Optional[PreemptionConfig] = None
    RejectJobRegistration: Optional[bool] = None
    SchedulerAlgorithm: Optional[str] = None


class SchedulerConfigurationResponse(BaseModel):
    KnownLeader: Optional[bool] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NextToken: Optional[str] = None
    RequestTime: Optional[int] = None
    SchedulerConfig: Optional[SchedulerConfiguration] = None


class SchedulerSetConfigurationResponse(BaseModel):
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    RequestTime: Optional[int] = None
    Updated: Optional[bool] = None


class SearchRequest(BaseModel):
    AllowStale: Optional[bool] = None
    AuthToken: Optional[str] = None
    Context: Optional[str] = None
    Filter: Optional[str] = None
    Headers: Optional[Dict[str, str]] = None
    Namespace: Optional[str] = None
    NextToken: Optional[str] = None
    Params: Optional[Dict[str, str]] = None
    PerPage: Optional[int] = None
    Prefix: Optional[str] = None
    Region: Optional[str] = None
    Reverse: Optional[bool] = None
    WaitIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    WaitTime: Optional[int] = None


class SearchResponse(BaseModel):
    KnownLeader: Optional[bool] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Matches: Optional[Dict[str, List[str]]] = None
    NextToken: Optional[str] = None
    RequestTime: Optional[int] = None
    Truncations: Optional[Dict[str, bool]] = None


class ServerHealth(BaseModel):
    Address: Optional[str] = None
    Healthy: Optional[bool] = None
    ID: Optional[str] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    LastTerm: Optional[conint(ge=0, le=18446744073709551616)] = None
    Leader: Optional[bool] = None
    Name: Optional[str] = None
    SerfStatus: Optional[str] = None
    StableSince: Optional[datetime] = None
    Version: Optional[str] = None
    Voter: Optional[bool] = None


class ServiceCheck(BaseModel):
    AddressMode: Optional[str] = None
    Advertise: Optional[str] = None
    Args: Optional[List[str]] = None
    Body: Optional[str] = None
    CheckRestart: Optional[CheckRestart] = None
    Command: Optional[str] = None
    Expose: Optional[bool] = None
    FailuresBeforeCritical: Optional[int] = None
    GRPCService: Optional[str] = None
    GRPCUseTLS: Optional[bool] = None
    Header: Optional[Dict[str, List[str]]] = None
    InitialStatus: Optional[str] = None
    Interval: Optional[int] = None
    Method: Optional[str] = None
    Name: Optional[str] = None
    OnUpdate: Optional[str] = None
    Path: Optional[str] = None
    PortLabel: Optional[str] = None
    Protocol: Optional[str] = None
    SuccessBeforePassing: Optional[int] = None
    TLSSkipVerify: Optional[bool] = None
    TaskName: Optional[str] = None
    Timeout: Optional[int] = None
    Type: Optional[str] = None


class ServiceRegistration(BaseModel):
    Address: Optional[str] = None
    AllocID: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Datacenter: Optional[str] = None
    ID: Optional[str] = None
    JobID: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Namespace: Optional[str] = None
    NodeID: Optional[str] = None
    Port: Optional[int] = None
    ServiceName: Optional[str] = None
    Tags: Optional[List[str]] = None


class SpreadTarget(BaseModel):
    Percent: Optional[conint(ge=0, le=255)] = None
    Value: Optional[str] = None


class TaskArtifact(BaseModel):
    GetterHeaders: Optional[Dict[str, str]] = None
    GetterMode: Optional[str] = None
    GetterOptions: Optional[Dict[str, str]] = None
    GetterSource: Optional[str] = None
    RelativeDest: Optional[str] = None


class TaskCSIPluginConfig(BaseModel):
    ID: Optional[str] = None
    MountDir: Optional[str] = None
    Type: Optional[str] = None


class TaskDiff(BaseModel):
    Annotations: Optional[List[str]] = None
    Fields: Optional[List[FieldDiff]] = None
    Name: Optional[str] = None
    Objects: Optional[List[ObjectDiff]] = None
    Type: Optional[str] = None


class TaskEvent(BaseModel):
    Details: Optional[Dict[str, str]] = None
    DiskLimit: Optional[int] = None
    DiskSize: Optional[int] = None
    DisplayMessage: Optional[str] = None
    DownloadError: Optional[str] = None
    DriverError: Optional[str] = None
    DriverMessage: Optional[str] = None
    ExitCode: Optional[int] = None
    FailedSibling: Optional[str] = None
    FailsTask: Optional[bool] = None
    GenericSource: Optional[str] = None
    KillError: Optional[str] = None
    KillReason: Optional[str] = None
    KillTimeout: Optional[int] = None
    Message: Optional[str] = None
    RestartReason: Optional[str] = None
    SetupError: Optional[str] = None
    Signal: Optional[int] = None
    StartDelay: Optional[int] = None
    TaskSignal: Optional[str] = None
    TaskSignalReason: Optional[str] = None
    Time: Optional[int] = None
    Type: Optional[str] = None
    ValidationError: Optional[str] = None
    VaultError: Optional[str] = None


class TaskGroupDiff(BaseModel):
    Fields: Optional[List[FieldDiff]] = None
    Name: Optional[str] = None
    Objects: Optional[List[ObjectDiff]] = None
    Tasks: Optional[List[TaskDiff]] = None
    Type: Optional[str] = None
    Updates: Optional[Dict[str, conint(ge=0, le=18446744073709551616)]] = None


class TaskGroupScaleStatus(BaseModel):
    Desired: Optional[int] = None
    Events: Optional[List[ScalingEvent]] = None
    Healthy: Optional[int] = None
    Placed: Optional[int] = None
    Running: Optional[int] = None
    Unhealthy: Optional[int] = None


class TaskGroupSummary(BaseModel):
    Complete: Optional[int] = None
    Failed: Optional[int] = None
    Lost: Optional[int] = None
    Queued: Optional[int] = None
    Running: Optional[int] = None
    Starting: Optional[int] = None
    Unknown: Optional[int] = None


class TaskHandle(BaseModel):
    DriverState: Optional[str] = None
    Version: Optional[int] = None


class TaskLifecycle(BaseModel):
    Hook: Optional[str] = None
    Sidecar: Optional[bool] = None


class TaskState(BaseModel):
    Events: Optional[List[TaskEvent]] = None
    Failed: Optional[bool] = None
    FinishedAt: Optional[datetime] = None
    LastRestart: Optional[datetime] = None
    Restarts: Optional[conint(ge=0, le=18446744073709551616)] = None
    StartedAt: Optional[datetime] = None
    State: Optional[str] = None
    TaskHandle: Optional[TaskHandle] = None


class Time(BaseModel):
    __root__: datetime


class UpdateStrategy(BaseModel):
    AutoPromote: Optional[bool] = None
    AutoRevert: Optional[bool] = None
    Canary: Optional[int] = None
    HealthCheck: Optional[str] = None
    HealthyDeadline: Optional[int] = None
    MaxParallel: Optional[int] = None
    MinHealthyTime: Optional[int] = None
    ProgressDeadline: Optional[int] = None
    Stagger: Optional[int] = None


class Vault(BaseModel):
    ChangeMode: Optional[str] = None
    ChangeSignal: Optional[str] = None
    Env: Optional[bool] = None
    Namespace: Optional[str] = None
    Policies: Optional[List[str]] = None


class VolumeMount(BaseModel):
    Destination: Optional[str] = None
    PropagationMode: Optional[str] = None
    ReadOnly: Optional[bool] = None
    Volume: Optional[str] = None


class VolumeRequest(BaseModel):
    AccessMode: Optional[str] = None
    AttachmentMode: Optional[str] = None
    MountOptions: Optional[CSIMountOptions] = None
    Name: Optional[str] = None
    PerAlloc: Optional[bool] = None
    ReadOnly: Optional[bool] = None
    Source: Optional[str] = None
    Type: Optional[str] = None


class WaitConfig(BaseModel):
    Max: Optional[int] = None
    Min: Optional[int] = None


class Float32(BaseModel):
    __root__: float


class Float64(BaseModel):
    __root__: float


class Int(BaseModel):
    __root__: int


class Int8(BaseModel):
    __root__: conint(ge=-128, le=127)


class Int32(BaseModel):
    __root__: int


class Int64(BaseModel):
    __root__: int


class Uint(BaseModel):
    __root__: conint(ge=0)


class Uint8(BaseModel):
    __root__: conint(ge=0, le=255)


class Uint16(BaseModel):
    __root__: conint(ge=0, le=65535)


class Uint64(BaseModel):
    __root__: conint(ge=0, le=18446744073709551616)


class CSINodeInfo(BaseModel):
    AccessibleTopology: Optional[CSITopology] = None
    ID: Optional[str] = None
    MaxVolumes: Optional[int] = None
    RequiresNodeStageVolume: Optional[bool] = None
    SupportsCondition: Optional[bool] = None
    SupportsExpand: Optional[bool] = None
    SupportsStats: Optional[bool] = None


class ConsulExposeConfig(BaseModel):
    Path: Optional[List[ConsulExposePath]] = None


class ConsulIngressListener(BaseModel):
    Port: Optional[int] = None
    Protocol: Optional[str] = None
    Services: Optional[List[ConsulIngressService]] = None


class ConsulProxy(BaseModel):
    Config_: Optional[Dict[str, Any]] = Field(None, alias="Config")
    ExposeConfig: Optional[ConsulExposeConfig] = None
    LocalServiceAddress: Optional[str] = None
    LocalServicePort: Optional[int] = None
    Upstreams: Optional[List[ConsulUpstream]] = None


class ConsulSidecarService(BaseModel):
    DisableDefaultTCPCheck: Optional[bool] = None
    Port: Optional[str] = None
    Proxy: Optional[ConsulProxy] = None
    Tags: Optional[List[str]] = None


class Deployment(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ID: Optional[str] = None
    IsMultiregion: Optional[bool] = None
    JobCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    JobID: Optional[str] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    JobSpecModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    JobVersion: Optional[conint(ge=0, le=18446744073709551616)] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Namespace: Optional[str] = None
    Status: Optional[str] = None
    StatusDescription: Optional[str] = None
    TaskGroups: Optional[Dict[str, DeploymentState]] = None


class JobDiff(BaseModel):
    Fields: Optional[List[FieldDiff]] = None
    ID: Optional[str] = None
    Objects: Optional[List[ObjectDiff]] = None
    TaskGroups: Optional[List[TaskGroupDiff]] = None
    Type: Optional[str] = None


class JobScaleStatusResponse(BaseModel):
    JobCreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    JobID: Optional[str] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    JobStopped: Optional[bool] = None
    Namespace: Optional[str] = None
    TaskGroups: Optional[Dict[str, TaskGroupScaleStatus]] = None


class JobSummary(BaseModel):
    Children: Optional[JobChildrenSummary] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    JobID: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Namespace: Optional[str] = None
    Summary: Optional[Dict[str, TaskGroupSummary]] = None


class MetricsSummary(BaseModel):
    Counters: Optional[List[SampledValue]] = None
    Gauges: Optional[List[GaugeValue]] = None
    Points: Optional[List[PointValue]] = None
    Samples: Optional[List[SampledValue]] = None
    Timestamp: Optional[str] = None


class Multiregion(BaseModel):
    Regions: Optional[List[MultiregionRegion]] = None
    Strategy: Optional[MultiregionStrategy] = None


class Namespace(BaseModel):
    Capabilities: Optional[NamespaceCapabilities] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Description: Optional[str] = None
    Meta: Optional[Dict[str, str]] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None
    Quota: Optional[str] = None


class NetworkResource(BaseModel):
    CIDR: Optional[str] = None
    DNS: Optional[DNSConfig] = None
    Device: Optional[str] = None
    DynamicPorts: Optional[List[Port]] = None
    Hostname: Optional[str] = None
    IP: Optional[str] = None
    MBits: Optional[int] = None
    Mode: Optional[str] = None
    ReservedPorts: Optional[List[Port]] = None


class NodeDevice(BaseModel):
    HealthDescription: Optional[str] = None
    Healthy: Optional[bool] = None
    ID: Optional[str] = None
    Locality: Optional[NodeDeviceLocality] = None


class NodeDeviceResource(BaseModel):
    Attributes: Optional[Dict[str, Attribute]] = None
    Instances: Optional[List[NodeDevice]] = None
    Name: Optional[str] = None
    Type: Optional[str] = None
    Vendor: Optional[str] = None


class NodeResources(BaseModel):
    Cpu: Optional[NodeCpuResources] = None
    Devices: Optional[List[NodeDeviceResource]] = None
    Disk: Optional[NodeDiskResources] = None
    MaxDynamicPort: Optional[int] = None
    Memory: Optional[NodeMemoryResources] = None
    MinDynamicPort: Optional[int] = None
    Networks: Optional[List[NetworkResource]] = None


class OperatorHealthReply(BaseModel):
    FailureTolerance: Optional[int] = None
    Healthy: Optional[bool] = None
    Servers: Optional[List[ServerHealth]] = None


class RaftConfiguration(BaseModel):
    Index: Optional[conint(ge=0, le=18446744073709551616)] = None
    Servers: Optional[List[RaftServer]] = None


class Resources(BaseModel):
    CPU: Optional[int] = None
    Cores: Optional[int] = None
    Devices: Optional[List[RequestedDevice]] = None
    DiskMB: Optional[int] = None
    IOPS: Optional[int] = None
    MemoryMB: Optional[int] = None
    MemoryMaxMB: Optional[int] = None
    Networks: Optional[List[NetworkResource]] = None


class SidecarTask(BaseModel):
    Config_: Optional[Dict[str, Any]] = Field(None, alias="Config")
    Driver: Optional[str] = None
    Env: Optional[Dict[str, str]] = None
    KillSignal: Optional[str] = None
    KillTimeout: Optional[int] = None
    LogConfig: Optional[LogConfig] = None
    Meta: Optional[Dict[str, str]] = None
    Name: Optional[str] = None
    Resources: Optional[Resources] = None
    ShutdownDelay: Optional[int] = None
    User: Optional[str] = None


class Spread(BaseModel):
    Attribute: Optional[str] = None
    SpreadTarget: Optional[List[SpreadTarget]] = None
    Weight: Optional[conint(ge=-128, le=127)] = None


class Template(BaseModel):
    ChangeMode: Optional[str] = None
    ChangeSignal: Optional[str] = None
    DestPath: Optional[str] = None
    EmbeddedTmpl: Optional[str] = None
    Envvars: Optional[bool] = None
    LeftDelim: Optional[str] = None
    Perms: Optional[str] = None
    RightDelim: Optional[str] = None
    SourcePath: Optional[str] = None
    Splay: Optional[int] = None
    VaultGrace: Optional[int] = None
    Wait: Optional[WaitConfig] = None


class AllocatedSharedResources(BaseModel):
    DiskMB: Optional[int] = None
    Networks: Optional[List[NetworkResource]] = None
    Ports: Optional[List[PortMapping]] = None


class AllocatedTaskResources(BaseModel):
    Cpu: Optional[AllocatedCpuResources] = None
    Devices: Optional[List[AllocatedDeviceResource]] = None
    Memory: Optional[AllocatedMemoryResources] = None
    Networks: Optional[List[NetworkResource]] = None


class AllocationMetric(BaseModel):
    AllocationTime: Optional[int] = None
    ClassExhausted: Optional[Dict[str, int]] = None
    ClassFiltered: Optional[Dict[str, int]] = None
    CoalescedFailures: Optional[int] = None
    ConstraintFiltered: Optional[Dict[str, int]] = None
    DimensionExhausted: Optional[Dict[str, int]] = None
    NodesAvailable: Optional[Dict[str, int]] = None
    NodesEvaluated: Optional[int] = None
    NodesExhausted: Optional[int] = None
    NodesFiltered: Optional[int] = None
    QuotaExhausted: Optional[List[str]] = None
    ResourcesExhausted: Optional[Dict[str, Resources]] = None
    ScoreMetaData: Optional[List[NodeScoreMeta]] = None
    Scores: Optional[Dict[str, float]] = None


class CSIInfo(BaseModel):
    AllocID: Optional[str] = None
    ControllerInfo: Optional[CSIControllerInfo] = None
    HealthDescription: Optional[str] = None
    Healthy: Optional[bool] = None
    NodeInfo: Optional[CSINodeInfo] = None
    PluginID: Optional[str] = None
    RequiresControllerPlugin: Optional[bool] = None
    RequiresTopologies: Optional[bool] = None
    UpdateTime: Optional[datetime] = None


class ConsulIngressConfigEntry(BaseModel):
    Listeners: Optional[List[ConsulIngressListener]] = None
    TLS: Optional[ConsulGatewayTLSConfig] = None


class Evaluation(BaseModel):
    AnnotatePlan: Optional[bool] = None
    BlockedEval: Optional[str] = None
    ClassEligibility: Optional[Dict[str, bool]] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    CreateTime: Optional[int] = None
    DeploymentID: Optional[str] = None
    EscapedComputedClass: Optional[bool] = None
    FailedTGAllocs: Optional[Dict[str, AllocationMetric]] = None
    ID: Optional[str] = None
    JobID: Optional[str] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ModifyTime: Optional[int] = None
    Namespace: Optional[str] = None
    NextEval: Optional[str] = None
    NodeID: Optional[str] = None
    NodeModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    PreviousEval: Optional[str] = None
    Priority: Optional[int] = None
    QueuedAllocations: Optional[Dict[str, int]] = None
    QuotaLimitReached: Optional[str] = None
    RelatedEvals: Optional[List[EvaluationStub]] = None
    SnapshotIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Status: Optional[str] = None
    StatusDescription: Optional[str] = None
    TriggeredBy: Optional[str] = None
    Type: Optional[str] = None
    Wait: Optional[int] = None
    WaitUntil: Optional[datetime] = None


class JobListStub(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Datacenters: Optional[List[str]] = None
    ID: Optional[str] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    JobSummary: Optional[JobSummary] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None
    Namespace: Optional[str] = None
    ParameterizedJob: Optional[bool] = None
    ParentID: Optional[str] = None
    Periodic: Optional[bool] = None
    Priority: Optional[int] = None
    Status: Optional[str] = None
    StatusDescription: Optional[str] = None
    Stop: Optional[bool] = None
    SubmitTime: Optional[int] = None
    Type: Optional[str] = None


class Node(BaseModel):
    Attributes: Optional[Dict[str, str]] = None
    CSIControllerPlugins: Optional[Dict[str, CSIInfo]] = None
    CSINodePlugins: Optional[Dict[str, CSIInfo]] = None
    CgroupParent: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Datacenter: Optional[str] = None
    Drain: Optional[bool] = None
    DrainStrategy: Optional[DrainStrategy] = None
    Drivers: Optional[Dict[str, DriverInfo]] = None
    Events: Optional[List[NodeEvent]] = None
    HTTPAddr: Optional[str] = None
    HostNetworks: Optional[Dict[str, HostNetworkInfo]] = None
    HostVolumes: Optional[Dict[str, HostVolumeInfo]] = None
    ID: Optional[str] = None
    LastDrain: Optional[DrainMetadata] = None
    Links: Optional[Dict[str, str]] = None
    Meta: Optional[Dict[str, str]] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None
    NodeClass: Optional[str] = None
    NodeResources: Optional[NodeResources] = None
    Reserved: Optional[Resources] = None
    ReservedResources: Optional[NodeReservedResources] = None
    Resources: Optional[Resources] = None
    SchedulingEligibility: Optional[str] = None
    Status: Optional[str] = None
    StatusDescription: Optional[str] = None
    StatusUpdatedAt: Optional[int] = None
    TLSEnabled: Optional[bool] = None


class NodeListStub(BaseModel):
    Address: Optional[str] = None
    Attributes: Optional[Dict[str, str]] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Datacenter: Optional[str] = None
    Drain: Optional[bool] = None
    Drivers: Optional[Dict[str, DriverInfo]] = None
    ID: Optional[str] = None
    LastDrain: Optional[DrainMetadata] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None
    NodeClass: Optional[str] = None
    NodeResources: Optional[NodeResources] = None
    ReservedResources: Optional[NodeReservedResources] = None
    SchedulingEligibility: Optional[str] = None
    Status: Optional[str] = None
    StatusDescription: Optional[str] = None
    Version: Optional[str] = None


class QuotaLimit(BaseModel):
    Hash: Optional[str] = None
    Region: Optional[str] = None
    RegionLimit: Optional[Resources] = None


class QuotaSpec(BaseModel):
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Description: Optional[str] = None
    Limits: Optional[List[QuotaLimit]] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Name: Optional[str] = None


class AllocatedResources(BaseModel):
    Shared: Optional[AllocatedSharedResources] = None
    Tasks: Optional[Dict[str, AllocatedTaskResources]] = None


class AllocationListStub(BaseModel):
    AllocatedResources: Optional[AllocatedResources] = None
    ClientDescription: Optional[str] = None
    ClientStatus: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    CreateTime: Optional[int] = None
    DeploymentStatus: Optional[AllocDeploymentStatus] = None
    DesiredDescription: Optional[str] = None
    DesiredStatus: Optional[str] = None
    EvalID: Optional[str] = None
    FollowupEvalID: Optional[str] = None
    ID: Optional[str] = None
    JobID: Optional[str] = None
    JobType: Optional[str] = None
    JobVersion: Optional[conint(ge=0, le=18446744073709551616)] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ModifyTime: Optional[int] = None
    Name: Optional[str] = None
    Namespace: Optional[str] = None
    NodeID: Optional[str] = None
    NodeName: Optional[str] = None
    PreemptedAllocations: Optional[List[str]] = None
    PreemptedByAllocation: Optional[str] = None
    RescheduleTracker: Optional[RescheduleTracker] = None
    TaskGroup: Optional[str] = None
    TaskStates: Optional[Dict[str, TaskState]] = None


class CSIPlugin(BaseModel):
    Allocations: Optional[List[AllocationListStub]] = None
    ControllerRequired: Optional[bool] = None
    Controllers: Optional[Dict[str, CSIInfo]] = None
    ControllersExpected: Optional[int] = None
    ControllersHealthy: Optional[int] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ID: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Nodes: Optional[Dict[str, CSIInfo]] = None
    NodesExpected: Optional[int] = None
    NodesHealthy: Optional[int] = None
    Provider: Optional[str] = None
    Version: Optional[str] = None


class ConsulGateway(BaseModel):
    Ingress: Optional[ConsulIngressConfigEntry] = None
    Mesh: Optional[Any] = None
    Proxy: Optional[ConsulGatewayProxy] = None
    Terminating: Optional[ConsulTerminatingConfigEntry] = None


class PlanAnnotations(BaseModel):
    DesiredTGUpdates: Optional[Dict[str, DesiredUpdates]] = None
    PreemptedAllocs: Optional[List[AllocationListStub]] = None


class ConsulConnect(BaseModel):
    Gateway: Optional[ConsulGateway] = None
    Native: Optional[bool] = None
    SidecarService: Optional[ConsulSidecarService] = None
    SidecarTask: Optional[SidecarTask] = None


class JobPlanResponse(BaseModel):
    Annotations: Optional[PlanAnnotations] = None
    CreatedEvals: Optional[List[Evaluation]] = None
    Diff: Optional[JobDiff] = None
    FailedTGAllocs: Optional[Dict[str, AllocationMetric]] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NextPeriodicLaunch: Optional[datetime] = None
    Warnings: Optional[str] = None


class Service(BaseModel):
    Address: Optional[str] = None
    AddressMode: Optional[str] = None
    CanaryMeta: Optional[Dict[str, str]] = None
    CanaryTags: Optional[List[str]] = None
    CheckRestart: Optional[CheckRestart] = None
    Checks: Optional[List[ServiceCheck]] = None
    Connect: Optional[ConsulConnect] = None
    EnableTagOverride: Optional[bool] = None
    Meta: Optional[Dict[str, str]] = None
    Name: Optional[str] = None
    OnUpdate: Optional[str] = None
    PortLabel: Optional[str] = None
    Provider: Optional[str] = None
    Tags: Optional[List[str]] = None
    TaskName: Optional[str] = None


class Task(BaseModel):
    Affinities: Optional[List[Affinity]] = None
    Artifacts: Optional[List[TaskArtifact]] = None
    CSIPluginConfig: Optional[TaskCSIPluginConfig] = None
    Config_: Optional[Dict[str, Any]] = Field(None, alias="Config")
    Constraints: Optional[List[Constraint]] = None
    DispatchPayload: Optional[DispatchPayloadConfig] = None
    Driver: Optional[str] = None
    Env: Optional[Dict[str, str]] = None
    KillSignal: Optional[str] = None
    KillTimeout: Optional[int] = None
    Kind: Optional[str] = None
    Leader: Optional[bool] = None
    Lifecycle: Optional[TaskLifecycle] = None
    LogConfig: Optional[LogConfig] = None
    Meta: Optional[Dict[str, str]] = None
    Name: Optional[str] = None
    Resources: Optional[Resources] = None
    RestartPolicy: Optional[RestartPolicy] = None
    ScalingPolicies: Optional[List[ScalingPolicy]] = None
    Services: Optional[List[Service]] = None
    ShutdownDelay: Optional[int] = None
    Templates: Optional[List[Template]] = None
    User: Optional[str] = None
    Vault: Optional[Vault] = None
    VolumeMounts: Optional[List[VolumeMount]] = None


class TaskGroup(BaseModel):
    Affinities: Optional[List[Affinity]] = None
    Constraints: Optional[List[Constraint]] = None
    Consul: Optional[Consul] = None
    Count: Optional[int] = None
    EphemeralDisk: Optional[EphemeralDisk] = None
    MaxClientDisconnect: Optional[int] = None
    Meta: Optional[Dict[str, str]] = None
    Migrate: Optional[MigrateStrategy] = None
    Name: Optional[str] = None
    Networks: Optional[List[NetworkResource]] = None
    ReschedulePolicy: Optional[ReschedulePolicy] = None
    RestartPolicy: Optional[RestartPolicy] = None
    Scaling: Optional[ScalingPolicy] = None
    Services: Optional[List[Service]] = None
    ShutdownDelay: Optional[int] = None
    Spreads: Optional[List[Spread]] = None
    StopAfterClientDisconnect: Optional[int] = None
    Tasks: Optional[List[Task]] = None
    Update: Optional[UpdateStrategy] = None
    Volumes: Optional[Dict[str, VolumeRequest]] = None


class Job(BaseModel):
    Affinities: Optional[List[Affinity]] = None
    AllAtOnce: Optional[bool] = None
    Constraints: Optional[List[Constraint]] = None
    ConsulNamespace: Optional[str] = None
    ConsulToken: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Datacenters: Optional[List[str]] = None
    DispatchIdempotencyToken: Optional[str] = None
    Dispatched: Optional[bool] = None
    ID: Optional[str] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Meta: Optional[Dict[str, str]] = None
    Migrate: Optional[MigrateStrategy] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Multiregion: Optional[Multiregion] = None
    Name: Optional[str] = None
    Namespace: Optional[str] = None
    NomadTokenID: Optional[str] = None
    ParameterizedJob: Optional[ParameterizedJobConfig] = None
    ParentID: Optional[str] = None
    Payload: Optional[str] = None
    Periodic: Optional[PeriodicConfig] = None
    Priority: Optional[int] = None
    Region: Optional[str] = None
    Reschedule: Optional[ReschedulePolicy] = None
    Spreads: Optional[List[Spread]] = None
    Stable: Optional[bool] = None
    Status: Optional[str] = None
    StatusDescription: Optional[str] = None
    Stop: Optional[bool] = None
    SubmitTime: Optional[int] = None
    TaskGroups: Optional[List[TaskGroup]] = None
    Type: Optional[str] = None
    Update: Optional[UpdateStrategy] = None
    VaultNamespace: Optional[str] = None
    VaultToken: Optional[str] = None
    Version: Optional[conint(ge=0, le=18446744073709551616)] = None


class JobPlanRequest(BaseModel):
    Diff: Optional[bool] = None
    Job: Optional[Job] = None
    Namespace: Optional[str] = None
    PolicyOverride: Optional[bool] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None


class JobRegisterRequest(BaseModel):
    EnforceIndex: Optional[bool] = None
    EvalPriority: Optional[int] = None
    Job: Optional[Job] = None
    JobModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    Namespace: Optional[str] = None
    PolicyOverride: Optional[bool] = None
    PreserveCounts: Optional[bool] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None


class JobValidateRequest(BaseModel):
    Job: Optional[Job] = None
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None


class JobVersionsResponse(BaseModel):
    Diffs: Optional[List[JobDiff]] = None
    KnownLeader: Optional[bool] = None
    LastContact: Optional[int] = None
    LastIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    NextToken: Optional[str] = None
    RequestTime: Optional[int] = None
    Versions: Optional[List[Job]] = None


class Allocation(BaseModel):
    AllocModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    AllocatedResources: Optional[AllocatedResources] = None
    ClientDescription: Optional[str] = None
    ClientStatus: Optional[str] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    CreateTime: Optional[int] = None
    DeploymentID: Optional[str] = None
    DeploymentStatus: Optional[AllocDeploymentStatus] = None
    DesiredDescription: Optional[str] = None
    DesiredStatus: Optional[str] = None
    DesiredTransition: Optional[DesiredTransition] = None
    EvalID: Optional[str] = None
    FollowupEvalID: Optional[str] = None
    ID: Optional[str] = None
    Job: Optional[Job] = None
    JobID: Optional[str] = None
    Metrics: Optional[AllocationMetric] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ModifyTime: Optional[int] = None
    Name: Optional[str] = None
    Namespace: Optional[str] = None
    NextAllocation: Optional[str] = None
    NodeID: Optional[str] = None
    NodeName: Optional[str] = None
    PreemptedAllocations: Optional[List[str]] = None
    PreemptedByAllocation: Optional[str] = None
    PreviousAllocation: Optional[str] = None
    RescheduleTracker: Optional[RescheduleTracker] = None
    Resources: Optional[Resources] = None
    Services: Optional[Dict[str, str]] = None
    TaskGroup: Optional[str] = None
    TaskResources: Optional[Dict[str, Resources]] = None
    TaskStates: Optional[Dict[str, TaskState]] = None


class CSIVolume(BaseModel):
    AccessMode: Optional[str] = None
    Allocations: Optional[List[AllocationListStub]] = None
    AttachmentMode: Optional[str] = None
    Capacity: Optional[int] = None
    CloneID: Optional[str] = None
    Context: Optional[Dict[str, str]] = None
    ControllerRequired: Optional[bool] = None
    ControllersExpected: Optional[int] = None
    ControllersHealthy: Optional[int] = None
    CreateIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    ExternalID: Optional[str] = None
    ID: Optional[str] = None
    ModifyIndex: Optional[conint(ge=0, le=18446744073709551616)] = None
    MountOptions: Optional[CSIMountOptions] = None
    Name: Optional[str] = None
    Namespace: Optional[str] = None
    NodesExpected: Optional[int] = None
    NodesHealthy: Optional[int] = None
    Parameters: Optional[Dict[str, str]] = None
    PluginID: Optional[str] = None
    Provider: Optional[str] = None
    ProviderVersion: Optional[str] = None
    ReadAllocs: Optional[Dict[str, Allocation]] = None
    RequestedCapabilities: Optional[List[CSIVolumeCapability]] = None
    RequestedCapacityMax: Optional[int] = None
    RequestedCapacityMin: Optional[int] = None
    RequestedTopologies: Optional[CSITopologyRequest] = None
    ResourceExhausted: Optional[datetime] = None
    Schedulable: Optional[bool] = None
    Secrets: Optional[CSISecrets] = None
    SnapshotID: Optional[str] = None
    Topologies: Optional[List[CSITopology]] = None
    WriteAllocs: Optional[Dict[str, Allocation]] = None


class CSIVolumeCreateRequest(BaseModel):
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None
    Volumes: Optional[List[CSIVolume]] = None


class CSIVolumeRegisterRequest(BaseModel):
    Namespace: Optional[str] = None
    Region: Optional[str] = None
    SecretID: Optional[str] = None
    Volumes: Optional[List[CSIVolume]] = None


ObjectDiff.update_forward_refs()
